/*
 *                   jfjji,.           H A M M E R H E A D  S H A R K W A R E
 *                  ,#######EL:                  http://www.hhsw.de
 *                   .,j######Kj       
 *                    ;W########G:     This  code  is  free software; you can
 *                   j#####G ,D#L:     redistribute it and/or modify it under
 *             .,;;,G#####D.           the  terms  of  the GNU General Public
 *           jE##########G             License   as  published  by  the  Free
 *             .,W######D.             Software  Foundation; either version 2
 *             :L#####K##G             of  the  License,  or (at your option)
 *           .f#####G;.t##:            any later version.
 *         ;L###ELi.    ,D,            
 *       iEEGWj                        This  code  is distributed in the hope
 *      tW;                            that  it  will  be useful, but without
 *     jf                              any warranty; without even the implied
 *    .Kt                              warranty of merchantability or fitness
 *    i:                               for  a particular purpose. See the GNU
 *    ;                                General   Public   License   for  more
 *    .                                details (http://www.gnu.org).
 *
 * @author mf@hhsw.de
 * @version 20041014
 */
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <iostream>

#include "bbdock.hh"
#include "bbdockrc.hh"

using namespace std;

/*
 * Fetch an icon from the resource configuration file,
 * the idea of this function is to get rid of the
 * BBDockRC object after loading the icon
 *
 * @param binary - name of the currently running binary
 * @param fw - width of frame window in pixels
 * @param fh - height of frame window in pixels
 */
BBDock *loadrc( char *binary, int fw, int fh )
{
	BBDockRC	rc( binary );

	return rc.load( fw, fh );
}

/*
 * Entry point
 */
int main( int argc, char **argv )
{
	BBDock	*dock;
	int		fw = 64;
	int		fh = 64;
	char 	*binary;

	for( binary = *argv; --argc; )
		if( **(++argv) != '-' )
			break;
		else
			switch( *((*argv)+1) )
			{
				default:
				case '?':
				case 'h':
					cout << "usage: " << binary << 
						" [-hvf] PNGFILE:COMMAND..." << endl <<
						"  -h       print this help" << endl <<
						"  -v       print version and quit" << endl <<
						"  -fw n    width of dock button" << endl <<
						"  -fh n    height of dock button" << endl;
					return 0;
				case 'v':
					cout << "bbdock, version 0.05 <mf@hhsw.de>" << endl;
					return 0;
				case 'f':
					if( !--argc )
						cerr << "error: missing argument !" << endl;

					if( *((*argv)+2) == 'w' )
						fw = atoi( *(++argv) );
					else
						fh = atoi( *(++argv) );
					break;
			}

	if( !argc &&
		(dock = loadrc( binary, fw, fh )) )
	{
		dock->run();
		delete dock;
	}
	else
	{
		for( ; argc--; argv++ )
		{
			char	*img;
			char	*cmd;

			if( (img = strtok( *argv, ":" )) &&
				(cmd = strtok( NULL, "" )) )
			{
				switch( fork() )
				{
					case -1:
						return -1;
					case 0:
						dock = new BBDock( img, cmd, fw, fh );
						dock->run();
						delete dock;
						return 0;
				}
			}
			else
			{
				cerr << "Invalid argument" << endl;
			}
		}
	}

	return 0;
}
